package com.jasamedika.medifirst2000.converter;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import org.springframework.stereotype.Component;

import com.google.gson.Gson;
import com.jasamedika.medifirst2000.converter.base.BaseVoConverter;
import com.jasamedika.medifirst2000.entities.Negara;
import com.jasamedika.medifirst2000.vo.NegaraVO;

/**
 * Converter class between Pasien and PasienVO
 * 
 * @author Askur
 */
@Component
public class NegaraConverter implements BaseVoConverter<NegaraVO, Negara> {


	@Override
	public Negara transferVOToModel(NegaraVO vo, Negara model) {
		if (null == model)
			model = new Negara();

		try {
			String[] fieldsToInclude = null;
			Map<String, Object> serialized = vo.serialize(fieldsToInclude,vo.getClass().getName());
			Gson gson = new Gson();
	        String json = gson.toJson(serialized);
	        model = gson.fromJson(json, Negara.class);
		} catch (Exception e) {
			e.printStackTrace();
		}
		
		return model;
	}

	@Override
	public List<NegaraVO> transferListOfModelToListOfVO(List<Negara> models, List<NegaraVO> vos) {

		if (null == vos)
			vos = new ArrayList<NegaraVO>();

		if (null == models)
			return vos;

		for (Negara pegawai : models) {
			NegaraVO vo = new NegaraVO();
			vo=transferModelToVO(pegawai, vo);
			vos.add(vo);
		}

		return vos;
	}

	@Override
	public NegaraVO transferModelToVO(Negara model, NegaraVO vo) {
		if (null == vo)
			vo = new NegaraVO();
		try {
			String[] fieldsToInclude = null;
			Map<String, Object> serialized = model.serialize(fieldsToInclude,model.getClass().getSimpleName());
			Gson gson = new Gson();
	        String json = gson.toJson(serialized);
	        vo = gson.fromJson(json, NegaraVO.class);
		} catch (Exception e) {
			e.printStackTrace();
		}

		return vo;
	}
	
	
	
	

}
